///////////////////////////////////////////////////////////////////////////////
//
// (c) Digi International Inc. 2003. All Rights Reserved
//
// Digi provides this document "as is," without warranty of any kind,
// either expressed or implied, including, but not limited to, the implied
// warranties of fitness or merchantability for a particular purpose. Digi
// may make improvements and/or changes in this document or in the product(s)
// and/or the program(s) described in this document at any time.
//
// This document could include technical inaccuracies or typographical errors.
// Changes are periodically made to the information herein; these changes may
// be incorporated in new editions of the publication.
//
// Digi International Inc.
// 11001 Bren Road East
// Minnetonka, MN 55343, USA
// Tel: +1 (952) 912-3444
// Fax: +1 (952) 912-4952
// http://www.digi.com/
//
///////////////////////////////////////////////////////////////////////////////
// FinderDlg.h : header file
//

#if !defined(AFX_FinderDLG_H__E271B4B9_259D_4ED2_AB7A_C3319367509E__INCLUDED_)
#define AFX_FinderDLG_H__E271B4B9_259D_4ED2_AB7A_C3319367509E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "addp.h"

/////////////////////////////////////////////////////////////////////////////
// CFinderDlg dialog

class CFinderDlg : public CDialog
{
// Construction
public:
	CFinderDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CFinderDlg)
	enum { IDD = IDD_FINDERDIALOG };
	CListCtrl	m_DeviceListCtrl;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFinderDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	
	// Generated message map functions
	//{{AFX_MSG(CFinderDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnWebUI();
	afx_msg void OnConfigureIP();
	afx_msg void OnRefresh();
	afx_msg void OnReboot();
	afx_msg void OnQueryDevice();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT StartADDPSearch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT AddADDPResult(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
	
private:
	void RemoveAllItemsFromList();
	addp_device_info_t* GetItemDeviceInfo(int iItem);
	addp_handle_t m_ADDPSearchHandle;
	// Column indexes
	enum { COL_IPADDRESS, COL_MACADDRESS, COL_NAME, COL_PRODUCT, COL_STATUS };
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FinderDLG_H__E271B4B9_259D_4ED2_AB7A_C3319367509E__INCLUDED_)
